#include <dir.h>
#include <dos.h>
#include <stdio.h>

#define FILSIZ 14
#define LINSIZ 79 - FILSIZ
#define MAXP 144
extern directvideo;

void ErrorForFile(char *file)
{
 printf("     Could not read file %s\n", file);
}

void newline(void)
{
 directvideo = 0;
 printf("\n");
 directvideo = 1;
}

char path[MAXP];
char fname[MAXP];

showchars(char *file)
{
 FILE *fp;
 char line[80], name[FILSIZ+1], ch;
 int  i, n;

 strcpy(fname, path);
 strcat(fname, file);
 memset(line, 0, 80);
 sprintf(name, "%-12s  ", file);
 strcpy(line, name);

 fp = fopen(fname, "rb");
 if (fp == NULL) ErrorForFile(file);
 n = fread(&line[FILSIZ], 1, LINSIZ, fp);
 n += FILSIZ;
 for (i = 0; i < n; i++)
 {
  ch = line[i];
  switch (ch)
  {
   case 0:
   case 7:
   case 8:
   case 9:
   case 10:
   case 13:
    ch = 4;
  }
  putch(ch);
 }
 newline();
 fclose(fp);
}

main(int argc, char **argv)
{
 struct ffblk ffb;
 int    attr = FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_ARCH;
 int    i, n;

 printf("\n");

 if (argc < 2)
 {
  printf("     PRECIS 1.0 requires at least one parameter:  the file name(s) (with or\n");
  printf("     without wild cards and with or without paths) of the file or files it\n");
  printf("     will read.  It displays the first %d characters of each file with \n", LINSIZ);
  printf("     (ASCII 4) replacing all characters with ASCII values 0, 7, 8, 9, 10,\n");
  printf("     and 13.\n");
  printf("\n");
  printf("     PRECIS 1.0 is public domain, December 1992 by Charles Lazo III.\n");
  exit(1);
 }
 directvideo = 1;
 for (i = 1; i < argc; i++)
 {
  strcpy(path, argv[i]);
  /* pick path off of filename */
  n = strlen(path) - 1;
  while (n > -1 && path[n] != '\\' && path[n] != ':') path[n--] = 0;
  findfirst(argv[i], &ffb, attr);
  showchars(ffb.ff_name);
  while (!findnext(&ffb)) showchars(ffb.ff_name);
  newline();
 }
}
